package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.ShopCashierService;
import com.gxwebsoft.shop.entity.ShopCashier;
import com.gxwebsoft.shop.param.ShopCashierParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 收银控制器
 *
 * @author 科技小王子
 * @since 2024-09-10 21:05:06
 */
@Api(tags = "收银管理")
@RestController
@RequestMapping("/api/shop/shop-cashier")
public class ShopCashierController extends BaseController {
    @Resource
    private ShopCashierService shopCashierService;

    @ApiOperation("分页查询收银")
    @GetMapping("/page")
    public ApiResult<PageResult<ShopCashier>> page(ShopCashierParam param) {
        // 使用关联查询
        return success(shopCashierService.pageRel(param));
    }

    @ApiOperation("查询全部收银")
    @GetMapping()
    public ApiResult<List<ShopCashier>> list(ShopCashierParam param) {
        PageParam<ShopCashier, ShopCashierParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(shopCashierService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(shopCashierService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:shopCashier:list')")
    @OperationLog
    @ApiOperation("根据id查询收银")
    @GetMapping("/{id}")
    public ApiResult<ShopCashier> get(@PathVariable("id") Integer id) {
        return success(shopCashierService.getById(id));
        // 使用关联查询
        //return success(shopCashierService.getByIdRel(id));
    }

    @ApiOperation("添加收银")
    @PostMapping()
    public ApiResult<?> save(@RequestBody ShopCashier shopCashier) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          shopCashier.setUserId(Long.valueOf(loginUser.getUserId()));
        }
        if (shopCashierService.save(shopCashier)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改收银")
    @PutMapping()
    public ApiResult<?> update(@RequestBody ShopCashier shopCashier) {
        if (shopCashierService.updateById(shopCashier)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除收银")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (shopCashierService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加收银")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<ShopCashier> list) {
        if (shopCashierService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改收银")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<ShopCashier> batchParam) {
        if (batchParam.update(shopCashierService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除收银")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (shopCashierService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
